from typing import Dict

from .command import Command


class Logic:

    def __init__(self):
        self.__commands = {}  # type: Dict[int, Command]

    def addCommand(self, command: Command):
        self.__commands[command.priority()] = command

    def executeCommands(self):
        commands = self.__commands.copy()
        self.__commands.clear()
        priorities = sorted(commands.keys())
        for priority in priorities:
            commands[priority].execute(self)
