from __future__ import annotations

from logic import Logic
from logic.command.Command import Command, STATE_PRIORITY
from state import State
from state.io import MainIO


class SaveStateCommand(Command):

    def __init__(self, state: State, fileName: str):
        self.__state = state
        self.__fileName = fileName

    def priority(self) -> int:
        return STATE_PRIORITY

    def execute(self, logic: Logic):
        MainIO.save(self.__fileName, self.__state)

