from .Direction import Direction

CHARACTER_CATEGORY_HERO = 1


class Character:
    def __init__(self, category: int = CHARACTER_CATEGORY_HERO):
        self.__category = category  # type: int
        self.__x = 0  # type: int
        self.__y = 0  # type: int
        self.__displayDirection = Direction.SOUTH
        self.__moveDirection = Direction.NONE
        self.__commandDirection = Direction.NONE
        self.__shift = 0  # type: int
        self.__speed = 2  # type: int

    @property
    def category(self) -> int:
        return self.__category

    @category.setter
    def category(self, category: int):
        self.__category = category

    @property
    def x(self) -> int:
        return self.__x

    @x.setter
    def x(self, x: int):
        self.__x = x

    @property
    def y(self) -> int:
        return self.__y

    @y.setter
    def y(self, y: int):
        self.__y = y

    @property
    def displayDirection(self) -> Direction:
        return self.__displayDirection

    @displayDirection.setter
    def displayDirection(self, direction: Direction):
        self.__displayDirection = direction
        
    @property
    def moveDirection(self) -> Direction:
        return self.__moveDirection

    @moveDirection.setter
    def moveDirection(self, direction: Direction):
        self.__moveDirection = direction

    @property
    def commandDirection(self) -> Direction:
        return self.__commandDirection

    @commandDirection.setter
    def commandDirection(self, commandDirection: Direction):
        self.__commandDirection = commandDirection

    @property
    def shift(self) -> int:
        return self.__shift

    @shift.setter
    def shift(self, shift: int):
        self.__shift = shift

    @property
    def speed(self) -> int:
        return self.__speed

    @speed.setter
    def speed(self, speed: int):
        self.__speed = speed
