import numpy as np

from state import Region
from ..IO import IO
from ..ObjectSerializer import ObjectSerializer


class RegionSerializer(ObjectSerializer):

    def write(self, io: IO, region: Region):
        io.writeString("region")
        io.writeNumpyArray(region.cells[..., 0:2])

    def read(self, io: IO) -> Region:
        assert io.readString() == "region"
        region = Region()
        array = io.readNumpyArray()
        width = array.shape[0]
        height = array.shape[1]
        cells = np.zeros([width, height, 3], dtype=np.uint8)
        cells[..., 0:2] = array[..., 0:2]
        region.cells = cells
        return region
